=== debian/changelog ===
qpdf (12.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 04 May 2025 17:33:53 -0400

qpdf (12.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 06 Apr 2025 17:18:26 -0400
