## qpdf 12.3.0

=== pkg-test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(qpdf-version LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 20)
find_package(qpdf)
add_executable(qpdf-version qpdf-version.cc)
target_link_libraries(qpdf-version qpdf::libqpdf)
