=== debian/changelog ===
qpdf (12.3.0-1) unstable; urgency=medium

  * New upstream release.
  * Includes fixes to issues with completion files (Closes: #1111509).
  * Includes fixes to allow printing to work in FIPS mode.
  * Standards version updated to 4.7.3; no changes needed.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 10 Jan 2026 15:16:36 -0500
