## qpdf 12.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # also find the version number here. generate_auto_job also reads the
 # version from here.
 project(qpdf
-  VERSION 12.2.0
+  VERSION 12.3.1
   LANGUAGES C CXX)
 
 # Honor CMAKE_REQUIRED_LIBRARIES when checking for include files. This
@@ -167,9 +167,10 @@
 endif()
 
 if(CXX_NEXT)
+  set(CMAKE_CXX_STANDARD 23)
+else()
+  # See also build-scripts/check-headers
   set(CMAKE_CXX_STANDARD 20)
-else()
-  set(CMAKE_CXX_STANDARD 17)
 endif()
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -388,4 +389,3 @@
 message(STATUS "  system: ${CPACK_SYSTEM_NAME}")
 message(STATUS "")
 if(MINGW)
-    message(STATUS "MinGW compiler: ${CMAKE_CXX_COMPILER}")
