## qpdf 12.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # also find the version number here. generate_auto_job also reads the
 # version from here.
 project(qpdf
-  VERSION 12.3.1
+  VERSION 12.3.2
   LANGUAGES C CXX)
 
 # Honor CMAKE_REQUIRED_LIBRARIES when checking for include files. This
