=== debian/changelog ===
qpdf (12.3.2-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 24 Jan 2026 15:45:16 -0500
